unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, CustomTwain,
  TwainReg, Controls, StdCtrls, ExtCtrls, Forms, Spin;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Button2: TButton;
    Button3: TButton;
    Twain1: TTwain;
    CheckBox1: TCheckBox;
    Panel1: TPanel;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    SpinEdit2: TSpinEdit;
    Label3: TLabel;
    SpinEdit3: TSpinEdit;
    Label4: TLabel;
    SpinEdit4: TSpinEdit;
    Label5: TLabel;
    SpinEdit5: TSpinEdit;
    ComboBox1: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    ComboBox2: TComboBox;
    GroupBox1: TGroupBox;
    Label8: TLabel;
    SpinEdit6: TSpinEdit;
    SpinEdit7: TSpinEdit;
    Label9: TLabel;
    SpinEdit8: TSpinEdit;
    Label10: TLabel;
    SpinEdit9: TSpinEdit;
    Label11: TLabel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Twain1BeforScan(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  with Twain1 do
  begin
    ShowUI := CheckBox1.Checked;
    if not ShowUI then
    begin
      Brightness := SpinEdit1.Value;
      Contrast := SpinEdit2.Value;
      HighLight := SpinEdit3.Value;
      Shadow := SpinEdit4.Value;
      Resolution := SpinEdit5.Value;
      PixelType := TScanPixelType(ComboBox1.ItemIndex);
      PaperSize := TPaperSize(ComboBox2.ItemIndex);
      if PaperSize = psCustom then
        Frame := Rect(SpinEdit6.Value, SpinEdit7.Value, SpinEdit8.Value, SpinEdit9.Value);
      FromFeeder := CheckBox2.Checked;
      Duplex := CheckBox3.Checked;
    end;
    if Scan then
      Image1.Picture.Assign(Twain1.DIB);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Twain1.SelectSource
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Twain1.CustomSelectSource
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Panel1.Visible := not CheckBox1.Checked
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  PT: TScanPixelType;
  PS: TPaperSize;
begin
  for PT := ptBW to ptRGB do
    ComboBox1.Items.Add(PixelTypeStr[PT]);
  for PS := psCustom to psUSLetter do
    ComboBox2.Items.Add(PaperSizeStr[PS]);
  ComboBox1.ItemIndex := 0;
  ComboBox2.ItemIndex := 2;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  GroupBox1.Visible := ComboBox2.ItemIndex = 0;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  CheckBox3.Enabled := CheckBox2.Checked
end;

procedure TForm1.Twain1BeforScan(Sender: TObject);
begin
  CheckBox2.Enabled := Twain1.HasFeeder;
  CheckBox3.Enabled := Twain1.HasDuplex;
end;

end.

